/*
    tcl-fuse - Tcl FUSE Interface
    A Tcl interface to the Linux kernel's FUSE subsystem.

    Copyright (C) 2008  Alexandros Stergiakis

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

/*
 * tclfuse.h
 *
 */

#include <fuse.h>
#include <tcl.h>

struct tclfuse_fsdata {
    struct fuse_operations *op;
    Tcl_Interp *interp;
    Tcl_Obj *fsname;
    int cmdtoken;
    Tcl_HashTable mounts;
    int mountcnt;
    Tcl_Obj *getattr;
    Tcl_Obj *readdir;
    Tcl_Obj *readlink;
    Tcl_Obj *rename;
    Tcl_Obj *mknod;
    Tcl_Obj *mkdir;
    Tcl_Obj *unlink;
    Tcl_Obj *rmdir;
    Tcl_Obj *symlink;
    Tcl_Obj *link;
    Tcl_Obj *chmod;
    Tcl_Obj *chown;
    Tcl_Obj *truncate;
    Tcl_Obj *open;
    Tcl_Obj *read;
    Tcl_Obj *write;
    Tcl_Obj *statfs;
    Tcl_Obj *flush;
    Tcl_Obj *release;
    Tcl_Obj *fsync;
    Tcl_Obj *setxattr;
    Tcl_Obj *getxattr;
    Tcl_Obj *listxattr;
    Tcl_Obj *removexattr;
    Tcl_Obj *opendir;
    Tcl_Obj *releasedir;
    Tcl_Obj *fsyncdir;
    Tcl_Obj *destroy;
    Tcl_Obj *access;
    Tcl_Obj *create;
    Tcl_Obj *ftruncate;
    Tcl_Obj *fgetattr;
    Tcl_Obj *lock;
    Tcl_Obj *utimens;
    Tcl_Obj *bmap;
    Tcl_Obj *userdata;
};

struct tclfuse_mpdata {
    struct tclfuse_fsdata *fsdata;
    struct fuse *fuse;
    Tcl_Channel chan;
    char *mountpoint;
};
