'\"
'\" Generated from file './doc/dtrace.man' by tcllib/doctools with format 'nroff'
'\" Copyright (c) 2008 Remigiusz 'lRem' Modrzejewski
'\"
'\" The definitions below are for supplemental macros used in Tcl/Tk
'\" manual entries.
'\"
'\" .AP type name in/out ?indent?
'\"	Start paragraph describing an argument to a library procedure.
'\"	type is type of argument (int, etc.), in/out is either "in", "out",
'\"	or "in/out" to describe whether procedure reads or modifies arg,
'\"	and indent is equivalent to second arg of .IP (shouldn't ever be
'\"	needed;  use .AS below instead)
'\"
'\" .AS ?type? ?name?
'\"	Give maximum sizes of arguments for setting tab stops.  Type and
'\"	name are examples of largest possible arguments that will be passed
'\"	to .AP later.  If args are omitted, default tab stops are used.
'\"
'\" .BS
'\"	Start box enclosure.  From here until next .BE, everything will be
'\"	enclosed in one large box.
'\"
'\" .BE
'\"	End of box enclosure.
'\"
'\" .CS
'\"	Begin code excerpt.
'\"
'\" .CE
'\"	End code excerpt.
'\"
'\" .VS ?version? ?br?
'\"	Begin vertical sidebar, for use in marking newly-changed parts
'\"	of man pages.  The first argument is ignored and used for recording
'\"	the version when the .VS was added, so that the sidebars can be
'\"	found and removed when they reach a certain age.  If another argument
'\"	is present, then a line break is forced before starting the sidebar.
'\"
'\" .VE
'\"	End of vertical sidebar.
'\"
'\" .DS
'\"	Begin an indented unfilled display.
'\"
'\" .DE
'\"	End of indented unfilled display.
'\"
'\" .SO
'\"	Start of list of standard options for a Tk widget.  The
'\"	options follow on successive lines, in four columns separated
'\"	by tabs.
'\"
'\" .SE
'\"	End of list of standard options for a Tk widget.
'\"
'\" .OP cmdName dbName dbClass
'\"	Start of description of a specific option.  cmdName gives the
'\"	option's name as specified in the class command, dbName gives
'\"	the option's name in the option database, and dbClass gives
'\"	the option's class in the option database.
'\"
'\" .UL arg1 arg2
'\"	Print arg1 underlined, then print arg2 normally.
'\"
'\" RCS: @(#) $Id: man.macros,v 1.1 2006/07/01 03:37:56 andreas_kupries Exp $
'\"
'\"	# Set up traps and other miscellaneous stuff for Tcl/Tk man pages.
.if t .wh -1.3i ^B
.nr ^l \n(.l
.ad b
'\"	# Start an argument description
.de AP
.ie !"\$4"" .TP \$4
.el \{\
.   ie !"\$2"" .TP \n()Cu
.   el          .TP 15
.\}
.ta \n()Au \n()Bu
.ie !"\$3"" \{\
&\$1	\fI\$2\fP	(\$3)
.\".b
.\}
.el \{\
.br
.ie !"\$2"" \{\
&\$1	\fI\$2\fP
.\}
.el \{\
&\fI\$1\fP
.\}
.\}
..
'\"	# define tabbing values for .AP
.de AS
.nr )A 10n
.if !"\$1"" .nr )A \w'\$1'u+3n
.nr )B \n()Au+15n
.\"
.if !"\$2"" .nr )B \w'\$2'u+\n()Au+3n
.nr )C \n()Bu+\w'(in/out)'u+2n
..
.AS Tcl_Interp Tcl_CreateInterp in/out
'\"	# BS - start boxed text
'\"	# ^y = starting y location
'\"	# ^b = 1
.de BS
.br
.mk ^y
.nr ^b 1u
.if n .nf
.if n .ti 0
.if n \l'\n(.lu\(ul'
.if n .fi
..
'\"	# BE - end boxed text (draw box now)
.de BE
.nf
.ti 0
.mk ^t
.ie n \l'\n(^lu\(ul'
.el \{\
.\"	Draw four-sided box normally, but don't draw top of
.\"	box if the box started on an earlier page.
.ie !\n(^b-1 \{\
\h'-1.5n'\L'|\n(^yu-1v'\l'\n(^lu+3n\(ul'\L'\n(^tu+1v-\n(^yu'\l'|0u-1.5n\(ul'
.\}
.el \}\
\h'-1.5n'\L'|\n(^yu-1v'\h'\n(^lu+3n'\L'\n(^tu+1v-\n(^yu'\l'|0u-1.5n\(ul'
.\}
.\}
.fi
.br
.nr ^b 0
..
'\"	# VS - start vertical sidebar
'\"	# ^Y = starting y location
'\"	# ^v = 1 (for troff;  for nroff this doesn't matter)
.de VS
.if !"\$2"" .br
.mk ^Y
.ie n 'mc \s12\(br\s0
.el .nr ^v 1u
..
'\"	# VE - end of vertical sidebar
.de VE
.ie n 'mc
.el \{\
.ev 2
.nf
.ti 0
.mk ^t
\h'|\n(^lu+3n'\L'|\n(^Yu-1v\(bv'\v'\n(^tu+1v-\n(^Yu'\h'-|\n(^lu+3n'
.sp -1
.fi
.ev
.\}
.nr ^v 0
..
'\"	# Special macro to handle page bottom:  finish off current
'\"	# box/sidebar if in box/sidebar mode, then invoked standard
'\"	# page bottom macro.
.de ^B
.ev 2
'ti 0
'nf
.mk ^t
.if \n(^b \{\
.\"	Draw three-sided box if this is the box's first page,
.\"	draw two sides but no top otherwise.
.ie !\n(^b-1 \h'-1.5n'\L'|\n(^yu-1v'\l'\n(^lu+3n\(ul'\L'\n(^tu+1v-\n(^yu'\h'|0u'\c
.el \h'-1.5n'\L'|\n(^yu-1v'\h'\n(^lu+3n'\L'\n(^tu+1v-\n(^yu'\h'|0u'\c
.\}
.if \n(^v \{\
.nr ^x \n(^tu+1v-\n(^Yu
\kx\h'-\nxu'\h'|\n(^lu+3n'\ky\L'-\n(^xu'\v'\n(^xu'\h'|0u'\c
.\}
.bp
'fi
.ev
.if \n(^b \{\
.mk ^y
.nr ^b 2
.\}
.if \n(^v \{\
.mk ^Y
.\}
..
'\"	# DS - begin display
.de DS
.RS
.nf
.sp
..
'\"	# DE - end display
.de DE
.fi
.RE
.sp
..
'\"	# SO - start of list of standard options
.de SO
.SH "STANDARD OPTIONS"
.LP
.nf
.ta 4c 8c 12c
.ft B
..
'\"	# SE - end of list of standard options
.de SE
.fi
.ft R
.LP
See the \fBoptions\fR manual entry for details on the standard options.
..
'\"	# OP - start of full description for a single option
.de OP
.LP
.nf
.ta 4c
Command-Line Name:	\fB\$1\fR
Database Name:	\fB\$2\fR
Database Class:	\fB\$3\fR
.fi
.IP
..
'\"	# CS - begin code excerpt
.de CS
.RS
.nf
.ta .25i .5i .75i 1i
..
'\"	# CE - end code excerpt
.de CE
.fi
.RE
..
.de UL
\$1\l'|0\(ul'\$2
..

.TH "dtrace" n 0.5  "TclDTrace extension"
.BS
.SH NAME
dtrace \- TclDTrace extension: Tcl front-end to the DTrace facility
.SH SYNOPSIS
package require \fBTcl \fR
.sp
package require \fBdtrace \fR
.sp
\fBdtrace::open\fR ?\fB-option\fR \fIvalue\fR ...? ?\fIinstrument\fR?
.sp
\fBdtrace::configure\fR \fIhandle\fR
.sp
\fBdtrace::configure\fR \fIhandle\fR
.sp
\fBdtrace::configure\fR \fIhandle\fR \fB-option\fR
.sp
\fBdtrace::configure\fR \fIhandle\fR \fB-option\fR \fIvalue\fR ?\fB-option\fR \fIvalue\fR ...?
.sp
\fBdtrace::grab\fR \fIhandle\fR \fIpid\fR
.sp
\fBdtrace::launch\fR \fIhandle\fR \fIcmd\fR
.sp
\fBdtrace::compile\fR \fIhandle\fR \fIprogram\fR ?\fIargument0\fR \fIargument1\fR ...?
.sp
\fBdtrace::exec\fR \fIcompiled_program\fR
.sp
\fBdtrace::info\fR \fIcompiled_program\fR
.sp
\fBdtrace::go\fR \fIhandle\fR ?\fIcallback\fR {\fIproc\fR ?\fIarg\fR?} ...?
.sp
\fBdtrace::stop\fR \fIhandle\fR
.sp
\fBdtrace::process\fR \fIhandle\fR ?\fIsleep\fR?
.sp
\fBdtrace::aggregations\fR \fIhandle\fR
.sp
\fBdtrace::list\fR \fIcompiled_program\fR \fIlist_callback\fR \fIhandle\fR
.sp
\fBlist_callback\fR \fIprobe\fR \fIarg\fR
.sp
\fBprobe_desc\fR \fIprobe\fR \fIcpu\fR \fIid\fR \fIarg\fR
.sp
\fBprobe_output\fR \fIprobe\fR \fIcpu\fR \fIid\fR \fIarg\fR \fItype\fR \fIdata\fR
.sp
\fBdrop\fR \fIcpu\fR \fIkind\fR \fIcount\fR \fImessage\fR \fIarg\fR
.sp
\fBerror\fR \fIprobe\fR \fIcpu\fR \fImessage\fR \fIarg\fR
.sp
\fBproc\fR \fIpid\fR \fImessage\fR \fIarg\fR
.sp
.BE
.SH DESCRIPTION
DTrace is a system profiling suite created by Sun Microsystems. It allows the
user to profile a program without modifying its text, or even without the need
to distract it if it is running. It consists of a set of library hooks called
\fIproviders\fR, a set of tools, a C API (libdtrace) and its own specially
crafted scripting language called D.
.PP
\fBTclDTrace\fR is a Tcl binding to libdtrace. It allows users to run
D scripts and process their results directly from Tcl. Together with DTrace
providers already present in Tcl, it forms an efficient and convenient
tool for performance analysis and has the potential to increase the
productivity of Tcl developers.
.SH COMMANDS
All \fBTclDTrace\fR commands are in the \fBdtrace\fR namespace.
.TP
\fBdtrace::open\fR ?\fB-option\fR \fIvalue\fR ...? ?\fIinstrument\fR?
Returns \fIhandle\fR. Opens DTrace. If everything went OK, then \fIhandle\fR
gets returned. If \fIinstrument\fR is 0, then no instrumentation will be
possible. This can be useful to just check if a script compiles.
Initial configuration options may be passed, see the \fBdtrace::configure\fR
call below for the options.
.sp
Side note: the name \fIopen\fR is derived from the fact that it internally
opens \fI/dev/dtrace/\fR devices.
.TP
\fBdtrace::configure\fR \fIhandle\fR
Closes DTrace. Tidies up. If you forget to do it, it will be fired
automatically on Tcl exit. Calling this explicitly when your program is running
may come handy if you want to release resources - this is the only way to free
claimed memory.
.TP
\fBdtrace::configure\fR \fIhandle\fR
.TP
\fBdtrace::configure\fR \fIhandle\fR \fB-option\fR
.TP
\fBdtrace::configure\fR \fIhandle\fR \fB-option\fR \fIvalue\fR ?\fB-option\fR \fIvalue\fR ...?
If no options are supplied, the command returns a list containing alternating
option names and values. If \fB-option\fR is supplied but no \fIvalue\fR
then the command returns the current value of the given option.  If one or more
pairs of \fB-option\fR and \fIvalue\fR are supplied, the command sets each
of the named \fB-option\fRs to the corresponding \fIvalue\fR; in this case
the return value is an empty string.
.sp
For binary options you can use the values \fI1\fR and \fI0\fR. For complete
options list consider \fILibDTrace Options\fR [http://dev.lrem.net/tcldtrace/wiki/LibDtrace#Options] -
note that you can use every option of the underlaying libdtrace api, just
prepend it with a \fI-\fR.
.sp
List of basic options (these get returned in the alternating list by the first
type of invocation):
.RS
.TP
\fB\fB-flowindent\fR\fR 1/0
Makes libdtrace handle flow indenting.
.TP
\fB\fB-quiet\fR\fR 1/0
Sets quiet mode.
.TP
\fB\fB-bufsize\fR\fR integer
Sets the buffer size.
.TP
\fB\fB-libdir\fR\fR string
Set path for DTrace libraries.
.TP
\fB\fB-foldpdesc\fR\fR 1/0
Whether probe descriptions should be folded into a string (on 1), or given as
an alternating list (on 0). See \fBCallbacks\fR. This is TclDTrace specific
and defaults to 1.
.TP
\fB\fB-arch\fR\fR string
\fISPECIFIC TO MAC OS X\fR: The target architecture, possible values \fIi386/x86_64/ppc/ppc64\fR. This should be given during initial configuration (see
\fBdtrace::open\fR).
.RE
.sp
libdtrace options may also be changed from within the scripts using a \fI#pragma directive\fR.
.sp
Lear more: \fISolaris Dynamic Tracing Guide\fR [http://docs.sun.com/app/docs/doc/817-6223/chp-opt?l=en&q=pragma&a=view]
.TP
\fBdtrace::grab\fR \fIhandle\fR \fIpid\fR
Grabs the process identified by \fIpid\fR. If it's a first call to \fBdtrace::grab\fR, then the \fI$target\fR macro will be set to \fIpid\fR. You
should run \fBdtrace::go\fR quickly, as it's the command to continue the
grabbed processes.
.TP
\fBdtrace::launch\fR \fIhandle\fR \fIcmd\fR
This creates a grabbed process by executing \fIcmd\fR and grabbing it
immediately. Unlike a call to Tcl's \fBexec\fR and then \fBdtrace::grab\fR,
this does not create race conditions. Like in \fBdtrace::grab\fR, process is
continued on \fBdtrace::go\fR.
.TP
\fBdtrace::compile\fR \fIhandle\fR \fIprogram\fR ?\fIargument0\fR \fIargument1\fR ...?
Compiles D \fIprogram\fR, which should be in the same format as a file passed
to \fIdtrace(1) -s\fR. You can pass additional \fIstring\fR arguments to the
program. Returns a handle \fIcompiled_program\fR if successful.
.TP
\fBdtrace::exec\fR \fIcompiled_program\fR
Executes the \fIcompiled_program\fR (enables instrumentation points). This
might be called multiple times, all the programs will get run (i.e. generate
data for processing) after \fBdtrace::go\fR. Returns an alternating name/value
list of program info:
.RS
.TP
\fB\fBaggregates\fR\fR int
the number of aggregates associated with this program
.TP
\fB\fBrecgens\fR\fR int
the number of record generating probes associated with this program
.TP
\fB\fBmatches\fR\fR int
the number of probes matched by this program
.TP
\fB\fBspeculations\fR\fR int
the number of speculations specified by this program
.RE
.TP
\fBdtrace::info\fR \fIcompiled_program\fR
Returns an alternating name/value list of program info for the \fIcompiled_program\fR (this is the same as previous call, but it doesn't enable the
instrumentation - can be used for handles with \fIinstrument\fR set to 0):
.RS
.TP
\fB\fBaggregates\fR\fR int
the number of aggregates associated with this program
.TP
\fB\fBrecgens\fR\fR int
the number of record generating probes associated with this
.TP
\fB\fBmatches\fR\fR int
the number of probes matched by this program
.TP
\fB\fBspeculations\fR\fR int
the number of speculations specified by this program
.RE
.TP
\fBdtrace::go\fR \fIhandle\fR ?\fIcallback\fR {\fIproc\fR ?\fIarg\fR?} ...?
Enables tracing. This is more or less equal to actually running the executed
programs - without it you will not get any data from them. Furthermore this
command continues the grabbed processes.
.sp
It also registers callbacks. For each callback you need to specify a list
containing the callback proc name and possible additional argument. Learn more
about callbacks at \fBCallbacks\fR. Possible callbacks names are:
.RS
.IP \(bu
\fBprobe_desc\fR
.IP \(bu
\fBprobe_output\fR
.IP \(bu
\fBdrop\fR
.IP \(bu
\fBerror\fR
.IP \(bu
\fBproc\fR
.RE
.TP
\fBdtrace::stop\fR \fIhandle\fR
Stops things ticking.
.TP
\fBdtrace::process\fR \fIhandle\fR ?\fIsleep\fR?
If \fIsleep\fR is set to 1 sleeps a while. Wakes up if something interesting
happens. Note that eventually it will not be necessary to use this kind of
sleeping - event loop will do. But, at the moment, you need to manually
schedule \fBdtrace::process\fR frequently enough to avoid drops (buffer holds
around 60K records), or even DTrace aborting (after 30secs without a call to
\fBdtrace::process\fR). This should change in future versions.
.sp
This command triggers processing data accumulated in the buffer. For each
record a relevant \fBCallbacks\fR is called.
.TP
\fBdtrace::aggregations\fR \fIhandle\fR
Returns a list containing alternating tuple - value pairs. Tuples are what is
found in script between [ and ]. In this list, each tuple is represented
by a simple list, whose members are the tuple members, divided by \fI,\fR in D
code. Values are simple numerics. \fBdtrace::aggregations\fR output can (and
should) be interpreted as a Tcl dict.
.TP
\fBdtrace::list\fR \fIcompiled_program\fR \fIlist_callback\fR \fIhandle\fR
For each of the probes matched by the \fIcompiled_program\fR, runs the \fIlist_callback\fR.
.PP
.SH CALLBACKS
.TP
\fBlist_callback\fR \fIprobe\fR \fIarg\fR
This returns a probe description. If \fB-foldpdesc\fR is set to 1, it is a
single string with format \fI[[[provider:] module:]
function:] name [[predicate] action]\fR. If \fB-foldpdesc\fR is
set to 0, this is an alternating list containing:
.RS
.TP
\fB\fBid\fR\fR int
the numerical probe id
.TP
\fB\fBprovider\fR\fR string
the provider
.TP
\fB\fBmodule\fR\fR string
the module
.TP
\fB\fBfunction\fR\fR string
the function
.TP
\fB\fBname\fR\fR string
the name
.RE
.TP
\fBprobe_desc\fR \fIprobe\fR \fIcpu\fR \fIid\fR \fIarg\fR
This is called for each firing probe.
Meaning of the arguments:
.RS
.TP
\fIprobe\fR
the probe description string (see \fBlist_callback\fR)
.TP
\fIcpu\fR
on which cpu did the probe fire
.TP
\fIid\fR
the probe id number
.TP
\fIarg\fR
extra argument, empty string if none
.RE
.TP
\fBprobe_output\fR \fIprobe\fR \fIcpu\fR \fIid\fR \fIarg\fR \fItype\fR \fIdata\fR
This is called for each probe that produced some output. That may be just a
trace, printfed string or a stack. At present the output is returned directly
as the string given by libdtrace and needs to be parsed by the user.
Meaning of the arguments:
.RS
.TP
\fIprobe\fR
the probe description string (see \fBlist_callback\fR)
.TP
\fIcpu\fR
on which cpu did the probe fire
.TP
\fIid\fR
the probe id number
.TP
\fIarg\fR
extra argument, empty string if none
.TP
\fItype\fR
the output type (see \fILibDTrace Buffered Output\fR [http://dev.lrem.net/tcldtrace/wiki/LibDtrace#Bufferedoutput]),
without the \fIDTRACEACT_\fR prefix.
.TP
\fIdata\fR
the actual output data
.RE
.sp
Some of the most interesting output types are:
.RS
.TP
USTACK
result of ustack()
.TP
JSTACK
result of jstack()
.TP
STACK
result of stack()
.TP
PRINTF
result of printf()
.RE
.TP
\fBdrop\fR \fIcpu\fR \fIkind\fR \fIcount\fR \fImessage\fR \fIarg\fR
Meaning of the arguments:
.RS
.TP
\fIcpu\fR
on which cpu did the drop occur
.TP
\fIkind\fR
what kind of drop it is (see below)
.TP
\fImessge\fR
message preconstructed for you by libdtrace
.TP
\fIarg\fR
extra argument, empty string if none
.RE
Kind is a string meaning:
.RS
.TP
AGGREGATION
drop to aggregation buffer
.TP
DYNAMIC
dynamic drop
.TP
DYNRINSE
dyn drop due to rinsing
.TP
DYNDIRTY
dyn drop due to dirty
.TP
SPEC
speculative drop
.TP
SPECBUSY
spec drop due to busy
.TP
SPECUNAVAIL
spec drop due to unavail
.TP
STKSTROVERFLOW
stack string tab overflow
.TP
DBLERROR
error in ERROR probe
.RE
.TP
\fBerror\fR \fIprobe\fR \fIcpu\fR \fImessage\fR \fIarg\fR
Meaning of the arguments:
.RS
.TP
\fIprobe\fR
the probe description string (see \fBlist_callback\fR)
.TP
\fIcpu\fR
on which cpu did the probe fire
.TP
\fImessage\fR
message preconstructed for you by libdtrace
.TP
\fIarg\fR
extra argument, empty string if none
.RE
.TP
\fBproc\fR \fIpid\fR \fImessage\fR \fIarg\fR
Meaning of the arguments:
.RS
.TP
\fIpid\fR
pid of the process the message is about
.TP
\fImessge\fR
message preconstructed for you by libdtrace
.TP
\fIarg\fR
extra argument, empty string if none
.RE
.PP
.SH EXAMPLES
.SS "BASIC SAMPLE PROGRAM"
.nf

package require Tcl 8.5
package require dtrace

# Display instructions
puts {Please input probes in the standard one-liner format:}
puts {[[[provider:] module:] function:] name [[predicate] action]}
puts {Empty probe (just enter) ends the input,}

# Get sources
set probes_sources [list]
set probes_count 1
puts "probe $probes_count:"
gets stdin probe_line
while {$probe_line != ""} {
        set probes_sources [linsert $probes_sources end $probe_line]
        set probes_count [expr {$probes_count + 1}]
        puts "probe $probes_count:"
        gets stdin probe_line
}
set probes_count [expr {$probes_count - 1}]

# Get them compiled and executed
set dhandle [dtrace open -foldpdesc 1]
set OK_count 0
set i 1
set compiled_probes [list]
foreach probe_line $probes_sources {
        if { [ catch {
                puts -nonewline "Processing probe $i: $probe_line "
                set i [expr {$i + 1}]
                puts -nonewline .
                set compiled [dtrace compile $dhandle $probe_line]
                puts -nonewline .
                set running [dtrace exec $compiled]
                puts -nonewline .
                set OK_count [expr {$OK_count + 1}]
                puts -nonewline " OK"
        } ] } { puts -nonewline "FAILED"}
        puts {}
}
if {$OK_count == 0} {
        puts "No probes run - exiting."
        dtrace close $dhandle
        exit
}

# Simple to show the output
puts "CPU\\tProbe"
proc callback {probe cpu id args} {
        puts "$cpu\\t$probe"
}

# Go go go!
dtrace go $dhandle probe_desc {callback {}}
set counter 10
while {$counter} {
        dtrace process $dhandle 1
        set counter [expr {$counter - 1}]
}
dtrace stop $dhandle
dtrace close $dhandle

.fi
.SS "NETWORK DTRACE SERVER"
One of the good features of Tcl is really easy networking. So here you go: an
example of how easy it is to create a telnet-operated DTrace server for
multiple clients.
.PP
Usage: Run the script with DTrace privileges. Then connect to the port 1986
with something telnet-compatible. Now you can enter your script. Enter a line
containing just GO to finish and enable tracing. Disconnect (close the
application) to finish - the server cleans up by itself.
.nf

package require Tcl 8.5
package require dtrace

proc accept {sock addr port} {
    global handles scripts
    set handles($sock) [::dtrace::open -foldpdesc 1]
    set scripts($sock) ""
    fconfigure $sock -buffering line
    fileevent $sock readable [list receive $sock $addr $port]
    puts "Client connected from $addr:$port"
}

proc receive {sock addr port} {
    global handles scripts
    if {[eof $sock] || [catch {gets $sock line}]} {
        close $sock
        ::dtrace::close $handles($sock)
        unset handles($sock) scripts($sock)
        puts "Client $addr:$port disconnected"
    } else {
        if {[string equal $line "GO"]} {
            ::dtrace::exec [::dtrace::compile $handles($sock) $scripts($sock)]
            ::dtrace::go $handles($sock) probe_desc [list callback $sock]
            puts $sock "CPU\\tid\\tprobe"
            dtraceLoop $sock
            puts "Tracing for $addr:$port started"
        } else {
            set scripts($sock) "$scripts($sock)\\n$line"
        }
    }
}

proc callback {probe cpu id sock} {
    puts $sock "$cpu\\t$id\\t$probe"
}

proc dtraceLoop {sock} {
    global handles
    catch {::dtrace::process $handles($sock)}
    after 300 dtraceLoop $sock
}

socket -server accept 1986
vwait forever

.fi
.SH "SEE ALSO"
dtrace(1)
.SH KEYWORDS
dtrace
.SH COPYRIGHT
.nf
Copyright (c) 2008 Remigiusz 'lRem' Modrzejewski

.fi